﻿define char01_sheet = "grid/01.png"
image char01 down:
    Crop((0, 0, 32, 32), char01_sheet)
    pause .2
    Crop((32, 0, 32, 32), char01_sheet)
    pause .2
    Crop((64, 0, 32, 32), char01_sheet)
    pause .2
    Crop((32, 0, 32, 32), char01_sheet)
    pause .2
    repeat

image char01 up:
    Crop((0, 96, 32, 32), char01_sheet)
    pause .2
    Crop((32, 96, 32, 32), char01_sheet)
    pause .2
    Crop((64, 96, 32, 32), char01_sheet)
    pause .2
    Crop((32, 96, 32, 32), char01_sheet)
    pause .2
    repeat

image char01 left:
    Crop((0, 32, 32, 32), char01_sheet)
    pause .2
    Crop((32, 32, 32, 32), char01_sheet)
    pause .2
    Crop((64, 32, 32, 32), char01_sheet)
    pause .2
    Crop((32, 32, 32, 32), char01_sheet)
    pause .2
    repeat

image char01 right:
    Crop((0, 64, 32, 32), char01_sheet)
    pause .2
    Crop((32, 64, 32, 32), char01_sheet)
    pause .2
    Crop((64, 64, 32, 32), char01_sheet)
    pause .2
    Crop((32, 64, 32, 32), char01_sheet)
    pause .2
    repeat
image coin:
    Crop((0, 0, 32, 32), "grid/coin.png")
    pause .2
    Crop((32, 0, 32, 32), "grid/coin.png")
    pause .2
    Crop((64, 0, 32, 32), "grid/coin.png")
    pause .2
    Crop((32, 0, 32, 32), "grid/coin.png")
    pause .2
    repeat


init python:
    class grid_piece:
        def __init__(self, img, rotation, blocked):
            self.img = img
            self.rotation = rotation
            self.blocked = blocked
    class grid_walker:
        def __init__(self, name, x, y):
            self.name = name
            self.direction = "down"
            self.x = x
            self.y = y
            self.cash = 0
            self.moves = 0
    class grid_puzzle_class:
        def __init__(self, solution, walker, size, targets):
            self.solution = solution
            self.grid = solution
            self.walker = grid_walker("char01",walker[0],walker[1])
            self.targets = targets
            self.size = size
            self.locked = False
            self.blocked = self.grid[self.walker.y][self.walker.x]

        def reset(self):
            pass
        def clicked(self, x, y):
            pass
        def move(self, direction):
            self.blocked = self.grid[self.walker.y][self.walker.x]
            self.walker.direction = direction
            if direction in self.blocked.blocked:
                pass
            else:
                if direction == "up":
                    self.walker.y -= 1
                elif direction == "left":
                    self.walker.x -= 1
                elif direction == "down":
                    self.walker.y += 1
                elif direction == "right":
                    self.walker.x += 1
                self.locked = True
                
        def collect(self):
            for i in self.targets:
                if i[0] == self.walker.x:
                    if i[1] == self.walker.y:
                        self.targets.remove(i)
                        self.walker.cash += 1

        def unlock(self):
            self.locked = False
            self.collect()
            self.walker.moves += 1
init:
    default g00 = grid_piece(
        0,0, []
    )

    default g10 = grid_piece(
        1,0, []
    )
    default g20 = grid_piece(
        2,0, ["up","left"]
    )
    default g21 = grid_piece(
        2,1, ["up","right"]
    )
    default g22 = grid_piece(
        2,2, ["down","right"]
    )
    default g23 = grid_piece(
        2,3, ["down","left"]
    )

    default g30 = grid_piece(
        3,0, ["up"]
    )
    default g31 = grid_piece(
        3,1, ["right"]
    )
    default g32 = grid_piece(
        3,2, ["down"]
    )
    default g33 = grid_piece(
        3,3, ["left"]
    )

    default g40 = grid_piece(
        4,0, ["left","right"]
    )
    default g41 = grid_piece(
        4,1, ["up","down"]
    )

    default g50 = grid_piece(
        5,0, ["left","up","right"]
    )
    default g51 = grid_piece(
        5,1, ["up","right","down"]
    )
    default g52 = grid_piece(
        5,2, ["right","down","left"]
    )
    default g53 = grid_piece(
        4,3, ["down","left","up"]
    )


default grid_1 = grid_puzzle_class(
    [
        [g20,g30,g21,g00],
        [g33,g10,g10,g21],
        [g33,g31,g52,g40],
        [g23,g32,g41,g22],
    ],
    [3,1], 100,
    [
        [0,0, "coin"], [1,2, "coin"], [3,3, "coin"], [0,2, "coin"], [2,2, "coin"],
    ],
)







screen grid_puzzle(g):
    # text str(g.blocked.blocked)
    hbox:
        align 0.0,0.0 offset 40,40 spacing 40
        text "Coins: [g.walker.cash]"
        text "Moves: [g.walker.moves]"
    modal True
    if g.locked:
        timer .3 repeat True action Function(g.unlock)
        key "w" action NullAction()
        key "a" action NullAction()
        key "s" action NullAction()
        key "d" action NullAction()
    else:
        key "w" action Function(g.move, "up")
        key "a" action Function(g.move, "left")
        key "s" action Function(g.move, "down")
        key "d" action Function(g.move, "right")
    add "grid/bg.png" align .5,.5
    fixed:
        fit_first True
        align .5,.5
        vbox:
            spacing 0 
            for j in g.grid:
                hbox:
                    spacing 0
                    for i in j:
                        button:
                            # at rotate(i.rotation*90)
                            xysize g.size,g.size #background "grid/{}.png".format(i.img)
                            # text str(i.rotation) align .5,.5
                            action Function(g.clicked, j, i)
        if len(g.targets):
            for i in g.targets:
                frame:
                    offset i[0]*g.size, i[1]*g.size
                    add i[2]
                    anchor .5,.5 pos 50,50 background None
        if g.walker:
            frame:
                at grid_ball(g.walker.x*g.size, g.walker.y*g.size)
                add "[g.walker.name] [g.walker.direction]"
                anchor .5,.5 pos 50,50 background None

    # frame:
    #     align .5,.5
    #     for m,j in enumerate(g.grid):
    #         for n,i in enumerate(j):
    #             button:
    #                 offset n*140,m*140
    #                 xysize 40,40 background "#fff9"
    #                 text str(i) 

transform grid_ball(x, y):
    ease .4 xoffset x yoffset y

transform rotate(r):
    rotate_pad False
    subpixel True
    rotate r
label grid_puzzle_example:
    
    call screen grid_puzzle(grid_1)
    return




